var ep;
var done = { global_hook_1: false, object_hook_simple: false, object_hook_complex: false };

function run_test()
{
    load("../../lib/utils.js");
    load("../../lib/events.js");

    // Give the whole test sequence 1 second to run.
    do_timeout(1000, "end_test()");

    ep = new CEventPump(10);
    var epo = new TestEventObject();

    do_test_pending();
    do_test_pending();
    do_test_pending();
    ep.addHook({ set: "test", type: "simple" }, global_hook_1, "global_hook_1");
    ep.addHook({ set: "test", type: "simple" }, global_hook_2, "global_hook_2");
    ep.removeHookByName("global_hook_1");
    ep.addEvent(new CEvent("test", "simple", epo, "onSimple"));
    do_timeout(10, "event_step()");
}

function event_step()
{
    do_timeout(10, "event_step()");
    ep.stepEvents();
}

function end_test()
{
    var l = [];
    for (var name in done)
    {
        if (!done[name])
            l.push(name);
    }
    dump("*** events which failed to occur: " + l.join(", ") + "\n");
    do_throw(l.length + " events failed.");
}

function global_hook_1(e)
{
    do_throw("Removed hook was called!");
}

function global_hook_2(e)
{
    done.global_hook_1 = true;
    do_test_finished();
}

function TestEventObject()
{
}

TestEventObject.prototype.onSimple =
function teo_onsimple(e)
{
    done.object_hook_simple = true;
    e.destObject = this;
    e.destMethod = "onComplex";
    do_test_finished();
}

TestEventObject.prototype.onComplex =
function teo_oncomplex(e)
{
    done.object_hook_complex = true;
    do_test_finished();
}
