@ECHO OFF

SETLOCAL ENABLEDELAYEDEXPANSION
REM These are all hard-coded for my machine for now. The in-tree test runner
REM gets all these as arguments, but this should work some of them out if
REM possible. (FIXME)
SET Path_XPCShell=C:\Users\James\Documents\Mozilla.org\ChatZilla\Installer\Windows\Source\xulrunner
SET Path_TopSrcDir_Unix=C:/Users/James/Documents/Mozilla.org/Development/Source/mozilla-central
SET Path_TopSrcDir_Native=C:\Users\James\Documents\Mozilla.org\Development\Source\mozilla-central

REM Recursively (/R) find all directories (/D) and run tests in "unit"
REM subdirectory when found.
FOR /R /D %%d IN (*) DO IF EXIST "%%d\unit" CALL :run_tests_in "%%d\unit"

ENDLOCAL
GOTO :EOF

:run_tests_in
SETLOCAL
SET Path_Tests=%~1

REM All files matching "test_*.js" are test files, so run each in turn.
FOR %%f IN ("%Path_Tests%\test_*.js") DO CALL :run_test "%%f"

ENDLOCAL
GOTO :EOF

:run_test
SETLOCAL
SET Test_File=%~1
SET Test_Name=%~n1
SET Test_Path=%~dp1
SET NATIVE_TOPSRCDIR=%Path_TopSrcDir_Native%
SET TOPSRCDIR=%Path_TopSrcDir_Unix%

REM Start with just the XPCShell test head and add all the test directory-
REM specific head files.
SET Tests_Head=-f "%TOPSRCDIR%/tools/test-harness/xpcshell-simple/head.js"
FOR %%f IN (head_*.js) DO SET Tests_Head=!Tests_Head! -f "%%~f"

REM Start with just the XPCShell test tail and add all the test directory-
REM specific tail files.
SET Tests_Tail=-f "%TOPSRCDIR%/tools/test-harness/xpcshell-simple/tail.js" -f "%TOPSRCDIR%/tools/test-harness/xpcshell-simple/execute_test.js"
FOR %%f IN (tail_*.js) DO SET Tests_Tail=!Tests_Tail! -f "%%~f"

REM Run XPCShell with a bunch of arguments; including the head and tail test
REM files (Tests_Head, Tests_Tail) and keep the log. We'll check the exit code
REM and log to see if it has passed.
PUSHD "%Test_Path%"
SET Test_Passed=0
"%Path_XPCShell%\xpcshell" -s %Tests_Head% -f "%Test_File%" %Tests_Tail% 1>"%Test_Name%.log" 2>&1
IF %ERRORLEVEL% EQU 0 SET /A Test_Passed=Test_Passed + 1
FOR /F "usebackq" %%l IN (`FINDSTR /C:"*** PASS" "%Test_Name%.log"`) DO SET /A Test_Passed=Test_Passed + 1
POPD

REM We have two requirements for passing, above: 0 exit code and at least
REM one "*** PASS" output line. If either is missing, Test_Passed will be less
REM than 2; this is what we check for failure here.
IF %Test_Passed% LSS 2 (
	ECHO TEST-UNEXPECTED-FAIL ^| %Test_File% ^| test failed, see log
	ECHO %Test_Name%.log:
	ECHO ^>^>^>^>^>^>^>
	TYPE "%Test_Path%\%Test_Name%.log"
	ECHO.
	ECHO ^<^<^<^<^<^<^<
) ELSE (
	ECHO TEST-PASS ^| %Test_File% ^| all tests passed
)

ENDLOCAL
GOTO :EOF
